// EntryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "interface.h"
#include "EntryDlg.h"
#include "interfaceDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEntryDlg dialog


CEntryDlg::CEntryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEntryDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEntryDlg)
	m_angAcc = 0;
	m_angV = 0;
	//}}AFX_DATA_INIT
}


void CEntryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEntryDlg)
	DDX_Text(pDX, IDC_ANG_ACC, m_angAcc);
	DDV_MinMaxInt(pDX, m_angAcc, -1000, 1000);
	DDX_Text(pDX, IDC_ANG_VELOCIT, m_angV);
	DDV_MinMaxInt(pDX, m_angV, -1000, 1000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEntryDlg, CDialog)
	//{{AFX_MSG_MAP(CEntryDlg)
	ON_EN_CHANGE(IDC_ANG_VELOCIT, OnChangeAngVelocit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEntryDlg message handlers

void CEntryDlg::OnChangeAngVelocit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	CFrameWnd * pFrame = (CFrameWnd *)(AfxGetApp()->m_pMainWnd);
    CInterfaceDoc *pDoc = (CInterfaceDoc *) pFrame->GetActiveDocument();
	UpdateData(TRUE);
   pDoc->m_a = m_angAcc;
   pDoc->m_w = m_angV;
	// TODO: Add your control notification handler code here

}

BOOL CEntryDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CFrameWnd * pFrame = (CFrameWnd *)(AfxGetApp()->m_pMainWnd);
    CInterfaceDoc *pDoc = (CInterfaceDoc *) pFrame->GetActiveDocument();
	
	m_angAcc = pDoc->m_a;
	m_angV = pDoc->m_w;
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
