// interfaceView.cpp : implementation of the CInterfaceView class
//

#include "stdafx.h"
#include "interface.h"
#include "Linkage.h"
#include "interfaceDoc.h"
#include "interfaceView.h"
#include <math.h>
#include <iostream.h>
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RANGE_M    10//range of Magnet

//#define PI       3.141592653589792895
/////////////////////////////////////////////////////////////////////////////
// CInterfaceView


IMPLEMENT_DYNCREATE(CInterfaceView, CView)

BEGIN_MESSAGE_MAP(CInterfaceView, CView)
	//{{AFX_MSG_MAP(CInterfaceView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONUP()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	///////////ITS ME
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInterfaceView construction/destruction
//char s[35] = "0,0";
CString s;
CString strA,strL;

LPCTSTR CInterfaceView::m_lpszClassName = NULL;


CInterfaceView::CInterfaceView() 
{
	// TODO: add construction code here
	m_LastPt.x = 0;
	m_LastPt.y = 0;
	m_fCplrDrawn = false;
	m_flagM = FALSE;
	m_flagA = FALSE;
	m_indexM = 0;



	m_rgnLastBL.CreateRectRgn(0,0,0,0);
	m_rgnLastBR.CreateRectRgn(0,0,0,0);
	m_rgnLastRA.CreateRectRgn(0,0,0,0);
	m_rgnLastRM.CreateRectRgn(0,0,0,0);
	
}

CInterfaceView::~CInterfaceView()
{

}

BOOL CInterfaceView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	//for OpenGL
//	cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

	return CView::PreCreateWindow(cs);
}

//////////////////////////////////////////////////////////////////////////
// CInterfaceView drawing/////////////////////////////////////////////////

void CInterfaceView::OnDraw(CDC* pDC)
{
	CInterfaceDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CClientDC dc(this);

	pDoc->m_hWnd = GetSafeHwnd();
/*	CRect rect;
	GetClientRect(&rect);
	dc.SetMapMode(MM_LOMETRIC);
	dc.SetWindowOrg(0,- rect.bottom);		
*/
//	if(!pDoc->m_flagD)
	{
	CClientDC dc(this); // device context for painting
	CBrush brush(RGB(0,0,0));
	CRect rect;
	GetClientRect(rect);
	dc.FillRect(&rect, &brush);
	// TODO: add draw code for native data here
	Draw(dc);
	}
	
}

/////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////
// CInterfaceView diagnostics

#ifdef _DEBUG
void CInterfaceView::AssertValid() const
{
	CView::AssertValid();
}

void CInterfaceView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CInterfaceDoc* CInterfaceView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CInterfaceDoc)));
	return (CInterfaceDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CInterfaceView message handlers

void CInterfaceView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CClientDC dc(this);
/*	CRect rect;
	GetClientRect(&rect);
	dc.SetMapMode(MM_LOMETRIC);
	dc.SetWindowOrg(0,- rect.bottom);	
	dc.DPtoLP(&point); 
*/	POSITION pos;
	CInterfaceDoc *pDoc  = GetDocument();
/*	if(pDoc->m_flag == 1) ::SetCursor(pDoc->m_hCross);
	if(pDoc->m_flag == 4) ::SetCursor(pDoc->m_hSelect);
	if(pDoc->m_flag == 5) ::SetCursor(pDoc->m_hSelect);
*/
//for link
///	CString strpt;
	if(pDoc->m_EndIndex < pDoc->m_TotalLink*2  && pDoc->m_flag == ID_TOOLS_LINK /*&& !(pDoc->m_EndIndex%2)*/ )
	{
		Magnet(point);
		m_LastPt = pDoc->m_End1 = m_pointM;
//		strpt.Format("%d,%d",m_LastPt.x,m_LastPt.y);
//		AfxMessageBox(strpt);
		pDoc->m_EndIndex++;
		pDoc->m_End2 = m_pointM;
//		pDoc->m_End2.y = m_pointM.y + 1;
		if(pDoc->m_EndIndex > 1 && pDoc->m_EndIndex%2)
		{
			m_flagA = TRUE;
		}
		else
			m_flagA = FALSE;
		if(pDoc->m_EndIndex > 0 && pDoc->m_EndIndex%2 /*&& pDoc->m_End1 != pDoc->m_End2*/)//a link should have some length
			pDoc->AddLink();
	}
//////for reference link
	if(pDoc->m_EndIndex > 0 && pDoc->m_flag == ID_TOOLS_REFERANCE && m_flagM && (pDoc->m_IndexRef < pDoc->m_EndIndex))
	{
		pDoc->m_ptRef[pDoc->m_IndexRef] = m_pointM;
		pDoc->m_IndexRef++;
	}
	CLink *plink;
	if(pDoc->m_IndexRef > 1)
		for(int i = 0; i < pDoc->m_IndexRef - 1; i += 2)
			if(pos = pDoc->GetLink(pDoc->m_ptRef[i],pDoc->m_ptRef[i+1]))
			{
				plink = (CLink*)pDoc->GetLink(pos);
				plink->m_IsRef = TRUE;
			}
///////for revolute joint
	if(pDoc->m_EndIndex > 0 && pDoc->m_flag == ID_TOOLS_REVOLUTE && m_flagM && (pDoc->m_IndexRev < pDoc->m_EndIndex/2))
	{	
		pDoc->m_ptRev[pDoc->m_IndexRev] = m_pointM;
		pDoc->m_IndexRev++;
	}
/////////////for slider
	bool prev;
	if(pDoc->m_flag == ID_TOOLS_SLIDER  )
	{
		prev = pDoc->m_linkCatchOn;
		pDoc->m_linkCatchOn = true;
	}

	CLink *pLink;
	int j;
	POSITION p;
	CString str;
	/////////////////////for coupler curve////////
	if(pDoc->m_flag == ID_TOOLS_COUPLER)
	{
		Magnet(point);
		if(!(pDoc->m_IndexCoupler%2))
		{
			if(p = pDoc->NearestLink(point,dc))
				if(pLink = pDoc->GetLink(p))
					pDoc->m_cplrLink = *pLink;
		}
		else
		{
			pDoc->m_cplrPt = point;
			pDoc->m_flag = 0;
			pDoc->m_linkCatchOn = prev;
		}
		pDoc->m_IndexCoupler++;

		if(pDoc->m_IndexCoupler >0)
		{
			pDoc->m_rc = distance(pDoc->m_cplrLink.m_pt1,pDoc->m_cplrPt);
			pDoc->m_ac = angle(pDoc->m_cplrLink.m_pt2,pDoc->m_cplrLink.m_pt1,pDoc->m_cplrPt);
		}
	}	

///////////////////////////////////////////////

	if(pDoc->m_EndIndex > 0 && pDoc->m_flag == ID_TOOLS_SLIDER && m_flagM && (pDoc->m_IndexSldr < pDoc->m_EndIndex))
	{
			Magnet(point);
		//get the first link to which slider will be attached
		if(!pDoc->m_IndexSldr%2)
		{
			pos = pDoc->NearestLink(m_pointM,dc);
			pLink = pDoc->GetLink(pos);
			if(distance(pLink->m_pt1,m_pointM) < distance(pLink->m_pt2,m_pointM))
				pDoc->m_ptSldr[pDoc->m_IndexSldr] = pLink->m_pt1;
			else
				pDoc->m_ptSldr[pDoc->m_IndexSldr] = pLink->m_pt2;
			pDoc->m_sldrAttachLink = *pLink;
		}
		//second link the path of which the slider will follow
		else
		{
			pos = pDoc->NearestLink(m_pointM,dc);
			pLink = pDoc->GetLink(pos);
			if(distance(pLink->m_pt1,m_pointM) < distance(pLink->m_pt2,m_pointM))
				pDoc->m_ptSldr[pDoc->m_IndexSldr] = pLink->m_pt1;
			else
				pDoc->m_ptSldr[pDoc->m_IndexSldr] = pLink->m_pt2;
			pDoc->m_flag = 0;
			pDoc->m_sldrPathLink = *pLink;

		}
		pDoc->m_IndexSldr++;
		pDoc->m_linkCatchOn = prev;
	}
	
//////////////////////////////////////////
/*	if(pDoc->m_flag == ID_TOOLS_RUN )
	{
		if(m_timerOn)
		{
			KillTimer(ID_TIMER);
			m_timerOn = FALSE;
		}
		else 
		{
			SetTimer(ID_TIMER,pDoc->m_timerValue,NULL);
			m_timerOn = TRUE;
		}
	//		pDoc->m_ra[1] += 20;
//		pDoc->LinkageCalc();
//		Draw(dc);
	}
*/
//////////////////FOR INPUT LINK SELECTION/////////////////////////////
	if(pDoc->m_flag == ID_TOOLS_INPUT)
	{
		pLink = pDoc->GetLink(pDoc->NearestLink(m_pointM,dc));
		pDoc->m_pInputLink = pLink;
		pDoc->m_flag = 0;
	}
//////////////////////////////////////////////

//	CLink *plink;
//	POSITION pos;
/*	if(pDoc->m_IndexRev > 1)
		for(int i = 0; i < pDoc->m_IndexRev - 1; i++)
			if(pos = pDoc->GetLink(pDoc->m_ptRef[i]))
			{
				plink = (CLink*)pDoc->GetLink(pos);
				plink->m_IsRef = TRUE;
			}
*/

///////deleting a link
	CPoint pt = point;
	if(pDoc->m_linkList.GetCount() > 0 && pDoc->m_flag == 5)
	{
		if((pos = pDoc->NearestLink(pt,dc)))
		{	pDoc->m_linkList.RemoveAt(pos);
			pDoc->m_EndIndex -= 2;
//			Invalidate();
		}
		
	}
		
//REMOVE COMMENTS 
//		pDoc->SetModifiedFlag();
	Draw(dc);
	CView::OnLButtonDown(nFlags, point);
}

void CInterfaceView::OnLButtonUp(UINT nFlags, CPoint point) 
{

//	dc.SetMapMode(MM_HIMETRIC);
	// TODO: Add your message handler code here and/or call default
	CView::OnLButtonUp(nFlags, point);
}

void CInterfaceView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CClientDC dc(this);
/*	CRect rect;
	GetClientRect(&rect);
	dc.SetMapMode(MM_LOMETRIC);
	dc.SetWindowOrg(0, - rect.bottom);	
	dc.DPtoLP(&point);
*/	CInterfaceDoc *pDoc  = GetDocument();
	if(pDoc->m_EndIndex > 0 && pDoc->m_EndIndex%2 ) 
	{
		pDoc->m_EndIndex--;
		pDoc->m_linkList.RemoveTail();
	}
	if(pDoc->m_EndIndex == 0)
		Invalidate();
	Draw(dc);
	CView::OnRButtonUp(nFlags, point);
}


void CInterfaceView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CClientDC dc(this);
	CInterfaceDoc *pDoc  = GetDocument();
/*	if(pDoc->m_flag == 1) ::SetCursor(pDoc->m_hCross);
	if(pDoc->m_flag == 4) ::SetCursor(pDoc->m_hSelect);
	if(pDoc->m_flag == 5) ::SetCursor(pDoc->m_hSelect);
*/
//	double ac = 0,aw = 0;
	if(pDoc->m_flag == ID_TOOLS_PLOTS)
	{  
		m_pointM = point;
		if(point.x > 50)
		{
			pDoc->m_ra[pDoc->m_InputLinkIndex] = (point.x - 50);
			Linkage(pDoc->m_rm,pDoc->m_ra,pDoc->m_w,pDoc->m_a,pDoc->m_InputLinkIndex,pDoc->m_indexR[0],pDoc->m_indexR[1],pDoc->m_indexA[0],pDoc->m_indexA[1],pDoc->m_drm,pDoc->m_dra,pDoc->m_ddrm,pDoc->m_ddra,pDoc->m_EndIndex/2);
		}
		s.Format("w = %lf,a = %lf,Angle = %d",pDoc->m_dra[2],pDoc->m_ddra[2],(point.x - 50)/2);
	}
	
	else
	{
//		POSITION pos;
		double a,l;
		//check should link be catched?
		if(pDoc->m_flag == ID_TOOLS_SLIDER)
			pDoc->m_linkCatchOn = TRUE;
		//catch the nearest point on link or end of link
		Magnet(point);	          
		//adding new link
		if(pDoc->m_EndIndex < pDoc->m_TotalLink*2 && pDoc->m_flag == ID_TOOLS_LINK) 
		{
			pDoc->m_End2 = m_pointM;	
			m_ptMM = point;
			if(pDoc->m_EndIndex%2)//add when new link is required to add
			{
				a = atan2((double)point.y - m_LastPt.y,(double)point.x - m_LastPt.x)*180.0/PI;
				strA.Format("%lf",a);
				pDoc->SetLinkTail();
			}
			else
				strA = "";
				
		}

		if(pDoc->m_flag == ID_TOOLS_COUPLER && pDoc->m_IndexCoupler%2)
			pDoc->m_cplrPt = point;

/*		
		if((pDoc->m_EndIndex%2))
		{
			a = atan2((double)point.y - m_LastPt.y,(double)point.x - m_LastPt.x)*180.0/PI;
			strA.Format("%lf",a);
		}
		else
			strA = "";
*/		
		////string to show coordinate at status bar/////////////////// 
		//NEWCHANGE
//		if(pDoc->m_flag != ID_TOOLS_PLOTS)
		s.Format("X = %ld,Y = %ld",m_pointM.x,m_pointM.y);
		
		/////showing the angle and length///////////////////////////////////
		if(pDoc->m_EndIndex > 0 && (pDoc->m_EndIndex)%2)
		{
			l = distance(m_pointM,m_LastPt);
			strL.Format("%lf",l);
		}
	////////////////////////////////////////
	}
	
////CHANGE THE MAP MODE AND SHOW THE COORDINATE ACCORDS TO IT	/////
/*	CRect rect;
	GetClientRect(&rect);
	dc.SetMapMode(MM_LOMETRIC);
	dc.DPtoLP(&rect);
	dc.SetWindowOrg(0,- rect.bottom);	
	dc.DPtoLP(&m_pointM);
	dc.DPtoLP(&m_LastPt);
*/

	/////////////////////////////////////
	////AGAIN CHANGE THE POINT FROM LOGICAL COORD TO DEVICE COORD
	/*	
		dc.LPtoDP(&m_pointM);
		dc.LPtoDP(&m_LastPt);
	*/
	Draw(dc);
	CView::OnMouseMove(nFlags, point);
}
//function which catch the point in range  of 10, set fNear TRUE for
//catching point on nearest link in range of 10
bool CInterfaceView::Magnet(CPoint point)
{

	CInterfaceDoc *pDoc  = GetDocument();
	double d = 9999.99,min_d,t;
	min_d = d;
	CClientDC dc(this);
	if(pDoc->m_EndIndex > 0)
	{
		for(int i = 0; i < pDoc->m_EndIndex; i++)
		{
			pDoc->GetLink(i/2);
			if((i+1)%2)
				t = pow((double)(pDoc->m_LinkCurr.m_pt1.x - point.x),2) + pow((double)(pDoc->m_LinkCurr.m_pt1.y - point.y),2);
			else
				t = pow((double)(pDoc->m_LinkCurr.m_pt2.x - point.x),2) + pow((double)(pDoc->m_LinkCurr.m_pt2.y - point.y),2);
			if( t<0)
				d = sqrtl(-t);
			else
				d = sqrtl(t);
			if(d < min_d)
			{
				m_indexM = i;
				min_d = d;
				
			}
		}
		
        if(min_d <= RANGE_M ) 
		{
            m_flagM = TRUE;
			pDoc->GetLink(m_indexM/2);
			if((m_indexM + 1)%2)
				m_pointM = pDoc->m_LinkCurr.m_pt1;
			else
				m_pointM = pDoc->m_LinkCurr.m_pt2;
		}			
		else
		{	
				if(pDoc->NearestLink(point,dc) && pDoc->m_linkCatchOn )
				{
					m_pointM = point;
					m_flagM = TRUE;
				}
			else
			{
				m_flagM = FALSE;
				m_pointM = point;
			}
		}
	}
	else
		m_pointM = point;
	if(pDoc->m_EndIndex <= 0)	m_flagM = FALSE;
	return m_flagM;
}

double CInterfaceView::slope(CPoint pt1, CPoint pt2)
{

	double a;
	if( pt2.y - pt1.y >= 0 && pt2.x - pt1.x == 0)
		a = PI/2.0;
	else if( pt2.y - pt1.y < 0 && pt2.x - pt1.x == 0)
		a = 1.5*PI;
	else
		a = atan2((double)(pt2.y - pt1.y),(double)(pt2.x - pt1.x));
	return a;
}



double CInterfaceView::angle(CPoint pt1, CPoint pt2, CPoint pt3)
{
	double a1,a2;

	if( (pt2.y-pt1.y) >= 0 && (pt2.x-pt1.x) == 0)
			a1 = 90;
		else if( (pt2.y-pt1.y) < 0 && (pt2.x-pt1.x) == 0)
			a1 = 270;
		else
			a1 = (double)atan2((double)(pt2.y - pt1.y),(double)(pt2.x - pt1.x))*180.0/PI;
		
//		wsprintf(str,"%ld",a1);
//	AfxMessageBox(str);
	if( (pt2.y-pt3.y) >= 0 && (pt2.x-pt3.x) == 0)
			a2 = 90;
		else if( (pt2.y-pt3.y) < 0 && (pt2.x-pt3.x) == 0)
			a2 = 270;
		else
			a2 = atan2((double)(pt2.y-pt3.y),(double)(pt2.x-pt3.x))*180.0/PI;
	return (a1-a2);
}

void CInterfaceView::makeRef(CPoint pt1,CPoint pt2,CDC *pDC)
{
	CInterfaceDoc *pDoc  = GetDocument();
	POSITION pos;
	CLink * plink;
	double m,d,c;
	if(pos = pDoc->GetLink(pt1,pt2))
	{
		plink = pDoc->GetLink(pos);
		m = slope(plink->m_pt1,plink->m_pt2); 
		c = plink->m_pt1.y - tan(m)*plink->m_pt1.x;
		d = distance(plink->m_pt1,plink->m_pt2);
		for(int i = 0; i < abs(plink->m_pt1.x - plink->m_pt2.x);i += abs(plink->m_pt1.x - plink->m_pt2.x)/10)
		{
			if(plink->m_pt1.x > plink->m_pt2.x)
			{
				pDC->MoveTo(plink->m_pt2.x + i,(int)(tan(m)*(plink->m_pt2.x + i) + c));
				pDC->LineTo((int)(plink->m_pt2.x + i + 10*cos(m+PI/4.0)),(int)(tan(m)*(plink->m_pt2.x + i) + c + 10*sin(m+PI/4.0)));
			}
			else
			{
				pDC->MoveTo(plink->m_pt1.x + i,(int)(tan(m)*(plink->m_pt1.x + i) + c));
				pDC->LineTo((int)(plink->m_pt1.x + i + 10*cos(m+PI/4.0)),(int)(tan(m)*(plink->m_pt1.x + i) + c + 10*sin(m+PI/4.0)));
			}
		}
	}
}


double CInterfaceView::distance(CPoint pt1,CPoint pt2)
{
	double d = ((double)(pt2.x-pt1.x)*(double)(pt2.x-pt1.x)+(double)(pt2.y-pt1.y)*(double)(pt2.y-pt1.y));
	if(d < 0)
		return sqrt(-d);
//	else
	return sqrt(d);
}

void CInterfaceView::makeRevJoint(CPoint pt,CDC *pDC)
{
	
	pDC->Ellipse(pt.x - 5, pt.y - 5, pt.x + 5, pt.y + 5);
	pDC->FillSolidRect(pt.x  - 2,pt.y -2 ,4,4,RGB(0,0,255));
}

void CInterfaceView::makeSliderJoint(CDC *pDC)
{
/*	CInterfaceDoc *pDoc  = GetDocument();
	POSITION pos;
	CLink * pLink;
	CPoint pt;
	double m;
	int i = 0,length  = 25,j = 0;
	pos = pDoc->GetLink(pDoc->m_sldrAttachLink.m_pt1,pDoc->m_sldrAttachLink.m_pt2);
	pLink = pDoc->GetLink(pos);
	if(pDoc->m_flag != ID_TOOLS_SLIDER)
	{
		for(i = 0; i < pDoc->m_IndexSldr; i+=2)
		{
			if(pDoc->m_ptSldr[i] == pLink->m_pt1)
				j = 0;
			else
				j = 1;
		}
	}
	if(j == 0)
		pt = pLink->m_pt1;
	else
		pt = pLink->m_pt2;
	m = ((double)(pDoc->m_sldrPathLink.m_pt2.y - pDoc->m_sldrPathLink.m_pt1.y)/(double)(pDoc->m_sldrPathLink.m_pt2.x - pDoc->m_sldrPathLink.m_pt1.x));
	for(i = 0; i < pDoc->m_IndexSldr; i+=2)
	{
		pDC->MoveTo(pt.x - length,pt.y + m*length);
		pDC->LineTo(pt.x + length,pt.y - m*length);
	
	}
		pDC->Ellipse(pt.x - 5, pt.y - 5, pt.x + 5, pt.y + 5);
*/
	
}


void CInterfaceView::Draw(CDC &dc)
{
	CInterfaceDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	/*sd//for changing the coordinate system.
	CRect rect;
	GetClientRect(&rect);
	dc.SetMapMode(MM_LOMETRIC);
	dc.SetWindowOrg(0, - rect.bottom);	
	*/
	//White Pen And Brush
	/*	
    CPen    penWhite(PS_SOLID|PS_GEOMETRIC, 1 ,RGB(255,255,255));
	CBrush  brushWhite(RGB(255,255,255));
	//Blank Pen & Brush
	CPen    penBlack(PS_SOLID|PS_GEOMETRIC,1,RGB(0,0,0));
	*/
	CBrush  brushBlack(RGB(0,0,0));
	
	CPen    penRed(PS_SOLID|PS_GEOMETRIC,2,RGB(255,0,0));
	CBrush  brushRed(RGB(255,0,0));

	CPen    penGreen(PS_SOLID|PS_GEOMETRIC,2,RGB(0,255,0));
	CBrush	brushGreen(RGB(0,255,0));

	CPen    penBlue(PS_SOLID|PS_GEOMETRIC,2,RGB(0,0,255));
	CBrush  brushBlue(RGB(0,0,255));

	CPen    penCplr(PS_SOLID|PS_GEOMETRIC,1,RGB(255,255,255));//pDoc->m_CplrColor
	CBrush  brushCplr(RGB(255,255,255));


	
//regions
	CRgn    rgnBlueL,rgnBlueR,rgnRedM,rgnNew,rgnBlue,rgnRed,rgnGreenS,rgnGreenP,rgnCplr,rgnBlueTR,rgnBlueTP,rgnBluePA,rgnRedPV,rgnBlueC;
//	CRgn	rgnBlackA,rgnBlackL,rgnBlackR,rgnBlackM,rgnBlackS,rgnBlackCplr,rgnCplrC;

//  saving the current object in pPen and setting new object as penBlack;
	CPen*   pPen = dc.SelectObject(&penRed);

//let us move.........


	dc.SetPolyFillMode(WINDING);

	

//////////////////////////////link//////////////////////////////
		
	if(pDoc->m_flag != ID_TOOLS_RUN && pDoc->m_flag != ID_TOOLS_PLOTS)
	{
		//declaration local
		int i;
		POSITION pos;
		CRgn rgnBlackL,rgnBlackR;//,rgnBlueL,rgnBlueR;
		dc.BeginPath();
			for(i = 0; i < pDoc->m_EndIndex; i += 2)
			{
				if(pDoc->GetLink(i/2) && pDoc->m_EndIndex >= 0 )
				{
					dc.MoveTo(pDoc->m_LinkCurr.m_pt1);
					dc.LineTo(pDoc->m_LinkCurr.m_pt2);
				}
/*			    if(m_flagA)
				{
					
					if(pos = pDoc->NearestLink(m_LastPt,dc))
						pDoc->GetLink(pos); 

//					dc.Ellipse(pDoc->m_Link.m_pt2.x - 5,pDoc->m_Link.m_pt2.y - 5, pDoc->m_Link.m_pt2.x + 5, pDoc->m_Link.m_pt2.y + 5);
				}
*/
			}
		dc.EndPath();
		dc.WidenPath();
		rgnBlueL.CreateFromPath(&dc);
		rgnBlackL.CreateRectRgn(0,0,0,0);
		rgnBlackL.CombineRgn(&m_rgnLastBL,&rgnBlueL,RGN_DIFF);
		dc.FillRgn(&rgnBlackL,&brushBlack);
		dc.FillRgn(&rgnBlueL, &brushBlue);

//		m_rgnLastBL.DeleteObject();
//		m_rgnLastBL.Attach(rgnBlueL.Detach());

/////////////////////ref rev////////////////////////////////
		if(pDoc->m_EndIndex > 1 )
		{

			dc.BeginPath();
				if((pDoc->m_flag == ID_TOOLS_REFERANCE &&  pDoc->m_IndexRef > 1)|| pDoc->m_IndexRef > 1)
					for(i = 0; i < pDoc->m_IndexRef - 1; i += 2)
						makeRef(pDoc->m_ptRef[i],pDoc->m_ptRef[i+1],&dc);
				if(pDoc->m_flag == ID_TOOLS_REVOLUTE || pDoc->m_IndexRev > 0)
					for(i = 0; i < pDoc->m_IndexRev; i ++)
				    	makeRevJoint(pDoc->m_ptRev[i],&dc);

			dc.EndPath();
			dc.WidenPath();
			rgnBlueR.CreateFromPath(&dc);
			rgnBlackR.CreateRectRgn(0,0,0,0);
			rgnBlackR.CombineRgn(&m_rgnLastBR,&rgnBlueR,RGN_DIFF);
			dc.FillRgn(&rgnBlackR,&brushBlack);
			dc.FillRgn(&rgnBlueR, &brushBlue);

//			m_rgnLastBR.DeleteObject();
//			m_rgnLastBR.Attach(rgnBlueR.Detach());

		}
	}//if(pDoc->m_flag != ID_TOOLS_RUN && pDoc->m_flag != ID_TOOLS_PLOTS)
///////////////////////////////////////////////////////////////////////////
	if(pDoc->m_flag == ID_TOOLS_COUPLER || ( pDoc->m_flag != ID_TOOLS_RUN && pDoc->m_flag != ID_TOOLS_PLOTS  && pDoc->m_IndexCoupler > 0))
	{
		CRgn rgnBlackC;
		dc.BeginPath();
			dc.MoveTo(pDoc->m_cplrLink.m_pt1);
			dc.LineTo(pDoc->m_cplrPt);
			dc.LineTo(pDoc->m_cplrLink.m_pt2);
		dc.EndPath();
		dc.WidenPath();
		rgnBlueC.CreateFromPath(&dc);
		rgnBlackC.CreateRectRgn(0,0,0,0);

		rgnBlackC.CombineRgn(&m_rgnLastC,&rgnBlueC,RGN_DIFF);

		dc.FillRgn(&rgnBlackC,&brushBlack);
		dc.FillRgn(&rgnBlueC, &brushBlue);
	}

	if(pDoc->m_flag == ID_TOOLS_RUN)
	{
		CRgn rgnBlackTR;//,rgnBlueTR;
		dc.BeginPath();
			pDoc->DrawLinkage(dc);
		dc.EndPath();
		dc.WidenPath();
		rgnBlueTR.CreateFromPath(&dc);
		rgnBlackTR.CreateRectRgn(0,0,0,0);

		rgnBlackTR.CombineRgn(&m_rgnLastTR,&rgnBlueTR,RGN_DIFF);

		dc.FillRgn(&rgnBlackTR,&brushBlack);
		dc.FillRgn(&rgnBlueTR, &brushBlue);

//		m_rgnLastTR.DeleteObject();
//		m_rgnLastTR.Attach(rgnBlueTR.Detach());
	}

//don't remember why
//		dc.MoveTo(0,0);

/////////////////////////////////////////////////////////////////////
	if(pDoc->m_flag == ID_TOOLS_PLOTS)
	{
		CRect rect;
		int cx,cy;
		CRgn rgnBlackP,rgnBlackPA,rgnBlackPV;//,rgnGreenP;
		GetClientRect(&rect);
		cx = rect.right;
		cy = rect.bottom;


		CString sa;
		dc.SetBkColor(TRANSPARENT);
		dc.SetTextColor(RGB(0,0,255));
		dc.TextOut(200,80,"Angle                    ");
		sa.Format("%12d",(m_pointM.x - 50)/2);//pDoc->m_ra[pDoc->m_InputLinkIndex]);
		dc.TextOut(300,80,sa);
		dc.SetTextColor(RGB(255,0,0));
		dc.TextOut(200,100,"Velocity                            ");
		sa.Format("%12.4lf",pDoc->m_dra[2]);
		dc.TextOut(300,100,sa);
		dc.SetTextColor(RGB(0,255,0));
		dc.TextOut(200,120,"Acceleration                                ");
		sa.Format("%12.4lf",pDoc->m_ddra[2]);
		dc.TextOut(300,120,sa);

		dc.MoveTo(50,cy/2);
		dc.LineTo(50 + 360*2,cy/2);
		dc.MoveTo(50,50);
		dc.LineTo(50,cy - 50);
//acceleration
		dc.BeginPath();
			acclPlot(dc);
		dc.EndPath();

		dc.WidenPath();
		rgnBluePA.CreateFromPath(&dc);
		rgnBlackPA.CreateRectRgn(0,0,0,0);		

		rgnBlackPA.CombineRgn(&m_rgnLastPA,&rgnBluePA,RGN_DIFF);
		dc.FillRgn(&rgnBlackPA, &brushBlack);
		dc.FillRgn(&rgnBluePA, &brushGreen);
//velocity
		dc.BeginPath();
			velocityPlot(dc);
		dc.EndPath();

		dc.WidenPath();
		rgnRedPV.CreateFromPath(&dc);
		rgnBlackPV.CreateRectRgn(0,0,0,0);		

		rgnBlackPV.CombineRgn(&m_rgnLastPV,&rgnRedPV,RGN_DIFF);
		dc.FillRgn(&rgnBlackPV, &brushBlack);
		dc.FillRgn(&rgnRedPV, &brushRed);
/*		dc.SelectObject(&penGreen);
		acclPlot(dc);

		dc.SelectObject(&penBlue);
		velocityPlot(dc);
*/
		dc.SelectObject(&penCplr);
		dc.BeginPath();
			dc.MoveTo(m_pointM.x,150);
			dc.LineTo(m_pointM.x,cy - 150);
		dc.EndPath();

		dc.WidenPath();
		rgnGreenP.CreateFromPath(&dc);
		rgnBlackP.CreateRectRgn(0,0,0,0);		

		rgnBlackP.CombineRgn(&m_rgnLastP,&rgnGreenP,RGN_DIFF);
		dc.FillRgn(&rgnBlackP,&brushBlack);
		dc.FillRgn(&rgnGreenP,&brushBlue);

//		m_rgnLastP.DeleteObject();
//		m_rgnLastP.Attach(rgnGreenP.Detach());
	}

//for slider	
	if((pDoc->m_EndIndex > 2 && pDoc->m_flag == ID_TOOLS_SLIDER &&  pDoc->m_IndexSldr > 1)|| (pDoc->m_IndexSldr > 1 && pDoc->m_flag != ID_TOOLS_PLOTS))
	{
		CRgn rgnBlackS;//,rgnGreenS;
		dc.BeginPath();
				makeSliderJoint(&dc);
		dc.EndPath();
		dc.WidenPath();
		rgnGreenS.CreateFromPath(&dc);
		rgnBlackS.CreateRectRgn(0,0,0,0);		
		rgnBlackS.CombineRgn(&m_rgnLastGS,&rgnGreenS,RGN_DIFF);
		dc.FillRgn(&rgnBlackS,&brushBlack);
		dc.FillRgn(&rgnGreenS,&brushGreen);

//		m_rgnLastGS.DeleteObject();
//		m_rgnLastGS.Attach(rgnGreenS.Detach());

	}
///////////////MAGNET RECTANGLE///////////////////////////////
	
	if(pDoc->m_flag != ID_TOOLS_RUN && pDoc->m_flag != ID_TOOLS_PLOTS)
	{
		CRgn rgnBlackM;//,rgnRedM;
		dc.BeginPath();
	
			//for win98
			//dc.FillSolidRect(m_pointM.x - 5,m_pointM.y - 5,10,10,RGB(255,0,0));
			//for winNT
			dc.Rectangle(m_pointM.x - 5,m_pointM.y - 5,m_pointM.x + 5,m_pointM.y + 5);
			
		dc.EndPath();
		dc.WidenPath();
		rgnRedM.CreateFromPath(&dc);
		rgnBlackM.CreateRectRgn(0,0,0,0);
		rgnBlackM.CombineRgn(&m_rgnLastRM,&rgnRedM,RGN_DIFF);
		dc.FillRgn(&rgnBlackM,&brushBlack);
		if(m_flagM)
			dc.FillRgn(&rgnRedM, &brushRed);

//		m_rgnLastRM.DeleteObject();
//		m_rgnLastRM.Attach(rgnRedM.Detach());

	}

////////////////////////for coupler curve////////////

	if(pDoc->m_flag == ID_TOOLS_RUN && pDoc->m_IndexCoupler > 0 )
	{
		CRgn	rgnBlackCplr;//,rgnCplr;


		dc.SelectObject(&penCplr);
		dc.BeginPath();
			
					pDoc->DrawCoupler(dc);
					m_fCplrDrawn = true;

		
		dc.EndPath();
		dc.WidenPath();
		rgnCplr.CreateFromPath(&dc);
		rgnBlackCplr.CreateRectRgn(0,0,0,0);
		rgnBlackCplr.CombineRgn(&m_rgnLastCplr,&rgnCplr,RGN_OR);	
		dc.FillRgn(&rgnCplr,&brushCplr);

//		m_rgnLastCplr.DeleteObject();
//		m_rgnLastCplr.Attach(rgnCplr.Detach());

	}

	pDoc->m_sCoord = s;


//	dc.FillRgn(&rgnBlackCplr,&brushBlack);
//	dc.FillRgn(&rgnCplrC,&brushCplr);



	
	//setting back the original object "Must do this"
	dc.SelectObject(pPen); //the Program after 45 rounds with an error "REQUIRED RESOURCE WAS UNAVILABLE." making the window hanged. 

	m_rgnLastBL.DeleteObject();
	m_rgnLastBL.Attach(rgnBlueL.Detach());

	m_rgnLastBR.DeleteObject();
	m_rgnLastBR.Attach(rgnBlueR.Detach());

	m_rgnLastRM.DeleteObject();
	m_rgnLastRM.Attach(rgnRedM.Detach());

	m_rgnLastGS.DeleteObject();
	m_rgnLastGS.Attach(rgnGreenS.Detach());
	
	m_rgnLastCplr.DeleteObject();
	m_rgnLastCplr.Attach(rgnCplr.Detach());

	m_rgnLastP.DeleteObject();
	m_rgnLastP.Attach(rgnGreenP.Detach());

  	m_rgnLastTR.DeleteObject();
	m_rgnLastTR.Attach(rgnBlueTR.Detach());

	m_rgnLastPA.DeleteObject();
	m_rgnLastPA.Attach(rgnBluePA.Detach());

	m_rgnLastPV.DeleteObject();
	m_rgnLastPV.Attach(rgnRedPV.Detach());

	m_rgnLastC.DeleteObject();
	m_rgnLastC.Attach(rgnBlueC.Detach());

////////////////////////////////////////////////////////////////////////////////////////////////
}




void CInterfaceView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CInterfaceDoc* pDoc = GetDocument();
	CClientDC dc(this);
	
	if(ID_TOOLS_RUN)
	{
		if((pDoc->m_ra[pDoc->m_InputLinkIndex] += 5) > 360)
			pDoc->m_ra[pDoc->m_InputLinkIndex] = 0;
//		pDoc->LinkageCalc();
		Draw(dc);
//		Invalidate();
	}
	CView::OnTimer(nIDEvent);
}

void CInterfaceView::acclPlot(CDC &dc)
{
	CInterfaceDoc* pDoc = GetDocument();
	CRect rect;
	int cx,cy;
	GetClientRect(&rect);
	cx = rect.right/2;
	cy = rect.bottom/2;
	
	pDoc->m_ra[pDoc->m_InputLinkIndex] = 0;
	Linkage(pDoc->m_rm,pDoc->m_ra,pDoc->m_w,pDoc->m_a,pDoc->m_InputLinkIndex,pDoc->m_indexR[0],pDoc->m_indexR[1],pDoc->m_indexA[0],pDoc->m_indexA[1],pDoc->m_drm,pDoc->m_dra,pDoc->m_ddrm,pDoc->m_ddra,pDoc->m_EndIndex/2);
	for(int i = 1; i <= 360; i++)
	{
		pDoc->m_ra[pDoc->m_InputLinkIndex] = i*2;
		dc.MoveTo(50 + i*2,cy - pDoc->m_ddra[2]);
		Linkage(pDoc->m_rm,pDoc->m_ra,pDoc->m_w,pDoc->m_a,pDoc->m_InputLinkIndex,pDoc->m_indexR[0],pDoc->m_indexR[1],pDoc->m_indexA[0],pDoc->m_indexA[1],pDoc->m_drm,pDoc->m_dra,pDoc->m_ddrm,pDoc->m_ddra,pDoc->m_EndIndex/2);
		dc.LineTo(50 + i*2,cy - pDoc->m_ddra[2]);
	}

}

void CInterfaceView::velocityPlot(CDC &dc)
{
	CInterfaceDoc* pDoc = GetDocument();
	CRect rect;
	GetClientRect(&rect);
	int cx,cy;
	cx = rect.right;
	cy = rect.bottom;
	
	pDoc->m_ra[pDoc->m_InputLinkIndex] = 0;
	Linkage(pDoc->m_rm,pDoc->m_ra,pDoc->m_w,pDoc->m_a,pDoc->m_InputLinkIndex,pDoc->m_indexR[0],pDoc->m_indexR[1],pDoc->m_indexA[0],pDoc->m_indexA[1],pDoc->m_drm,pDoc->m_dra,pDoc->m_ddrm,pDoc->m_ddra,pDoc->m_EndIndex/2);
	for(int i = 1; i <= 360; i++)
	{
		pDoc->m_ra[pDoc->m_InputLinkIndex] = i*2;
		dc.MoveTo(50 + i*2,cy/2 -  pDoc->m_dra[2]*2);
		Linkage(pDoc->m_rm,pDoc->m_ra,15,5,pDoc->m_InputLinkIndex,pDoc->m_indexR[0],pDoc->m_indexR[1],pDoc->m_indexA[0],pDoc->m_indexA[1],pDoc->m_drm,pDoc->m_dra,pDoc->m_ddrm,pDoc->m_ddra,pDoc->m_EndIndex/2);
		dc.LineTo(50 + i*2, cy/2 - pDoc->m_dra[2]*2) ;
	}

}


CPoint CInterfaceView::NearestPixel(CDC &dc, CPoint point,COLORREF color)
{
	int j,k;
//	double d;
	CPoint pt_n;
	for(j = -6; j <= 6;j++)
	{
		for(k = -6; k <= 6; k++)
		{
			pt_n.x = point.x + k;
			pt_n.y = point.y + j;
			if(dc.GetPixel(pt_n) == color)  
				return pt_n	;
		}
	}
	return NULL;
}


