#include "complex.h"
/*
#include <math.h>
#include <iostream.h>
#include <conio.h>
#define PI 3.141592653589793


class CComplex

{
public:
	double m_R,m_I;
public :
	CComplex();
	CComplex(double);
//	CComplex(int,int);
	CComplex(double,double);
	CComplex(const CComplex&);
	CComplex& operator=(const CComplex&);
//	bool  operator==(const CComplex&);
//	bool  operator!=(const CComplex&);
	CComplex operator!();//will return conjugate of this complex.
	CComplex operator*(const CComplex&);
	CComplex operator*(const double&);
	CComplex operator+(const CComplex&);
//	friend ostream& operator<<(ostream& ,const CComplex&);
//	friend istream& operator>>(istream& ,CComplex&);
};
*/
CComplex::CComplex()
{
	m_R = 0;
	m_I = 0;
}
CComplex::CComplex(double a)
{
	m_R = cos(a*PI/180);
	m_I = sin(a*PI/180);
}
CComplex::CComplex(double real,double img)
{
	m_R = real;
	m_I = img;
}
CComplex::CComplex(const CComplex& cmplx)
{
	m_R = cmplx.m_R;
	m_I = cmplx.m_I;
}
CComplex& CComplex::operator=(const CComplex& cmplx)
{
	m_R = cmplx.m_R;
	m_I = cmplx.m_I;
	return *this;
}
CComplex CComplex::operator*(const CComplex& c)
{
	CComplex mc;
	mc.m_R = m_R*c.m_R - m_I*c.m_I;
	mc.m_I = m_R*c.m_I + m_I*c.m_R;
	return mc;

}
CComplex CComplex::operator*(const double& r)
{
	CComplex mc;
	mc.m_R = r*m_R;
	mc.m_I = r*m_I;
	return mc;
}
CComplex CComplex::operator+(const CComplex& c)
{
	CComplex s;
	s.m_R = m_R + c.m_R;
	s.m_I = m_I + c.m_I;
	return s;
}
/*
ostream& operator<<(ostream& o,const CComplex& c)
{
	o<<c.m_R<<"+"<<c.m_I<<"i"<<endl;
	return o;
}
istream& operator>>(istream& i,CComplex& c)
{
	cout<<"enter real:";
	i >> c.m_R;
	cout<<"enter img:";
	i>>c.m_I;
	return i;
}
*/
/*
main()
{
clrscr();
 CComplex  c1(2,3),c2(4),c3,c4;
 c3 = c1*CComplex(0);
 c4 =  CComplex(c1);
 cout<<c1<<"  "<<c2<<"  " <<c3<<c4;
 getch();
 }
*/




















































































