// Link.cpp: implementation of the CLink class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "interface.h"
#include "Link.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL(CLink,CObject,0)


CLink::CLink() :m_pt1(0,0),m_pt2(0,0),m_IsRef(FALSE)
{	
	
}

CLink::CLink(CPoint pt1, CPoint pt2)
{
	m_pt1 = pt1;
	m_pt2 = pt2;
	m_IsRef = FALSE;
}
CLink::~CLink()
{

}

CLink::CLink(const CLink &link)
{
	m_pt1 = link.m_pt1;
	m_pt2 = link.m_pt2;
}
CLink& CLink::operator=(const CLink& link)
{
	m_pt1 = link.m_pt1;
	m_pt2 = link.m_pt2;
	return *this;
}
bool CLink::operator==(const CLink& link)
{
	if(m_pt1 == link.m_pt1 && m_pt2 == link.m_pt2)
		return TRUE;
	else
		return FALSE;
}

void CLink::Serialize(CArchive &ar)
{
	int nIsRef;
	CObject::Serialize(ar);
	if(ar.IsStoring())
	{
		ar<<m_pt1<<m_pt2;
		if(m_IsRef)
			ar<<1;
		else
			ar<<0;
	}
	else
	{
		ar>>m_pt1>>m_pt2>>nIsRef;
		if(nIsRef == 1)
			m_IsRef == TRUE;
		else if(nIsRef == 0)
			m_IsRef == FALSE;
	}

}
/*
CArchive& CLink::operator <<(CArchive &ar, CLink &link)
{
	if(ar.IsStoring())
		ar<<m_pt1<<m_pt2<<m_IsRef;
	return ar;
	
}
CArchive& CLink::operator >>(CArchive &ar, CLink &link)
{
	if(!ar.IsStoring())
		ar<<m_pt1<<m_pt2<<m_IsRef;
	return ar;
}
*/