// Link.h: interface for the CLink class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LINK_H__6733BF07_C2E9_11D4_9102_CEE61FB64101__INCLUDED_)
#define AFX_LINK_H__6733BF07_C2E9_11D4_9102_CEE61FB64101__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Joint.h"	// Added by ClassView


class CLink : public CObject  
{
DECLARE_SERIAL(CLink)

public:
//	CArchive& operator <<(CArchive &ar,CLink &link);
//	CArchive& operator>>(CArchive &ar,CLink &link);
	void Serialize(CArchive &ar);
	CLink(const CLink & link);
	CLink& operator=(const CLink& link);
	bool operator==(const CLink& link);

	CJoint *m_pJoint1,*m_pJoint2;//pointer to the joints at the ends.
	CPoint m_pt1,m_pt2;//Ends of Link.

	bool m_IsRef;//flag, is it referance or not ?? use for drawing referance hatching
	CLink();
	CLink(CPoint pt1, CPoint pt2);
	virtual ~CLink();

};

#endif // !defined(AFX_LINK_H__6733BF07_C2E9_11D4_9102_CEE61FB64101__INCLUDED_)
