
#include "StdAfx.h"
#include "complex.h"

//status for dreve function
#define CONSTNT  0
#define COEFF1 1
#define COEFF2 2
//for iteRAtion : eqn converge to
#define CONVTO .0001

//PARAMETER TO BE PASSED IN FUNCN Linkage() FOR INDEX?? IF NO INDEX IS TO BE SET
//#define NONE  -1
#include "Linkage.h"



int level = 0;
double *RM,*RA,*dRA,*dRM,*ddRM,*ddRA;
int TotalLink;//
void Linkage(double *rm,double *ra, double w,double a,int indexInput,int indexRX,int indexRY , int indexAX,int indexAY, double *drm,double *dra,double *ddrm,double *ddra,int totalLink) 
{
	RM = rm;
	RA = ra;
	dRM = drm;
	dRA = dra;
	ddRM = ddrm;
	ddRA = ddra;
	TotalLink = totalLink;
	double dx,dy;
	CComplex dex,dey,de = 1,e = 1,dde,ddex,ddey;
	int iter = 0;

//	while((RA[1] += 30) <= 360){ //rotate the link 2
	
	level = 0;//position analysis
	double *x,*y;
	if(indexRX != NONE)
		x = &dRM[indexRX];
	else
		x = &dRA[indexAX];
	if(indexRY != NONE)
		y = &dRM[indexRY];
	else
		y = &dRA[indexAY];
//	*y = &dRA[3];//
	e = 1;de = 1;//error > CONVTO
	iter = 0; //iteRAtion counter
	while( (fabs(e.m_R) > CONVTO || fabs(e.m_I) > CONVTO) && iter++ <= 40)
	{
		level = 0;//position analysis
		e  = loopeq();//error in loop closure eqn
		level = 1;//
		dex = param(x,y,COEFF1);//get the first coeff. of error eqn
		dey = param(x,y,COEFF2);//get the second coeff. of erroe eqn
		//solve the error eqn and get the error in dependant variable
		lineareq(dex.m_R,dex.m_I,dey.m_R,dey.m_I,e.m_R,e.m_I,&dx,&dy);
		if(indexRX != NONE)
			RM[indexRX] += dx;
		else
			RA[indexAX] += dx*180.0/PI;
		if(indexRY != NONE)
			RM[indexRY] += dy;
		else
			RA[indexAY] += dy*180.0/PI;
/*		RA[2] += dx*180.0/PI;
		RA[3] += dy*180.0/PI;
*/
//		cout<<"dex : "<<dex<<"dey : "<<dey<<"e : "<<e<<"dx : "<<dx<<"\ndy : "<<dy<<"\nr3 : "<<RA[2]<<"\nr4 : "<<RA[3]<<endl;
//		getch();
	}
//	RA[2] = ((int)RA[2])%360;
//	RA[3] = ((int)RA[3])%360;
	if(indexAX != NONE)
	{
		RA[indexAX] -= (((int)RA[2])/360)*360;
		if(RA[indexAX] < 0) RA[indexAX] = 360 + RA[indexAX];
	}
	if(indexAY != NONE)
	{
		RA[indexAY] -= (((int)RA[indexAY])/360)*360;
		if(RA[indexAY] < 0) RA[indexAY] = 360 + RA[indexAY];
	}
//	cout<<setw(4)<<RA[1]<<setw(12)<<RA[2]<<setw(12)<<RA[3];
	if(iter > 20)
//		AfxMessageBox("Cannot Converge");
//		cout<<"cannot converge"<<endl;
//coeff will be remain same for error eqn, velocity eqn and acceleRAtion eqn.
//constant will be different
//final coeffs
	dex = param(x,y,COEFF1);
	dey = param(x,y,COEFF2);

	//VELOCITY ANALYSIS
	level = 1;
	//make all unknowns or dependants zero
	*x = 0; *y = 0;
	dRA[indexInput] = w;
	//get the constant for the velocity eqn
	de  = param(x,y,CONSTNT);
	lineareq(dex.m_R,dex.m_I,dey.m_R,dey.m_I,de.m_R,de.m_I,x,y);
//	cout<<"\ndex : "<<dex<<"dey : "<<dey<<"de : "<<de<<"dRA3 : "<<dRA[2]<<","<<*x<<"\ndRA4 : "<<dRA[3]<<","<<*y<<endl;
//	getch();
//	cout<<setw(12)<<dRA[2]<<setw(12)<<dRA[3];
	//ACCELERTION ANALYSIS
	dRA[indexInput] = w;
	level = 2;
	//
	for(int i = 0; i<TotalLink; i++)
	{
		ddRA[i] = 0;
		ddRM[i] = 0;
	}
	ddRA[indexInput] = a;
//get the constant for acceleRAtion eqn
	dde  = param(x,y,CONSTNT);
	if(indexRX != NONE)
		x = &ddRM[indexRX];
	else
		x = &ddRA[indexAX];
	if(indexRY != NONE)
		y = &ddRM[indexRY];
	else
		y = &ddRA[indexAY];
/*
	x = &ddRA[2];//variable 1
	y = &ddRA[3];//variable 2
*/
	lineareq(dex.m_R,dex.m_I,dey.m_R,dey.m_I,dde.m_R,dde.m_I,x,y);
//	cout<<"\ndex : "<<dex<<"dey : "<<dey<<"de : "<<dde<<"dRA3 : "<<ddRA[2]<<"\ndRA4 : "<<ddRA[3]<<endl;
//	cout<<setw(13)<<(int)ddRA[2]<<setw(13)<<(int)ddRA[3]<<endl;
//	getch();
//	} //while r[1]== 360
	
}
//calculate the loop eqn based on the level
CComplex loopeq()
{
	CComplex loop;
	for(int i =0; i < TotalLink;i++)
		loop = loop + vector(i);
	return loop;
}
//prcondition : set the proper level
CComplex vector(int i)
{
	CComplex r,z,cexp;
	if(level == 0)
	//	z.m_R = RM[i];
		z = CComplex(RM[i],0.0);
	if(level == 1)
		z = CComplex(dRM[i],dRA[i]*RM[i]);
	if(level == 2)
		z = CComplex(ddRM[i] - RM[i]*dRA[i]*dRA[i],2.0*dRA[i]*dRM[i] + ddRA[i]*RM[i]);
	r = z*CComplex(RA[i]);
	return r;
}
void lineareq(double a1,double a2,double b1,double b2,double c1,double c2,double *x,double *y)
{
	 if(a2*b1 - a1* b2)
	{
		*x = (c1*b2 - b1*c2)/(a2*b1 - a1* b2);
		*y = (c2*a1 - c1*a2)/(a2*b1 - a1* b2);
	}
	else;
//		cout<<"err";

}
//get the CONSTANT OR COEFFICIENT paRAmeter of loop eqn
//set level = 1 or 2
//preconditions :
//set all knowns
//clear(0) all uknowns
CComplex param(double *x,double *y,int status)
{
	CComplex de;
	int i;
	if(level == 1 || level == 2)
	{
		if(status == 0)
		{
			de = loopeq();
		}
		if(status == 1)
		{
			for( i =0; i<TotalLink;i++)
				dRA[i] = dRM[i] = 0;
			*x = 1;*y = 0;
			de = loopeq();
		}
		if(status == 2)
		{
/*			for( i =0; i<TotalLink;i++)
				dRA[i] = dRM[i] = 0;
*/			*x = 0;*y = 1;
			de = loopeq();
		}
	}
	return de;
}